import { HttpClient, HttpParams, HttpHeaders } from '@angular/common/http';
import { HttpEvent, HttpHandler, HttpInterceptor, HttpRequest } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/shareReplay';
import 'rxjs/add/observable/throw';
import 'rxjs/add/operator/catch';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/do';
import { LocalStorageCacheService } from "./local-storage-cache.service";
export declare class HttpWrapperService {
    private http;
    private baseUrl;
    private url;
    constructor(http: HttpClient, baseUrl?: string);
    setRelativeUrl(urlConetxt: string): void;
    get<T>(url: string, httpParams?: HttpParams | {}, httpHeadres?: HttpHeaders | {}, isFullResponse?: boolean): Observable<T>;
    post<T>(url: string, body: any, httpHeadres?: HttpHeaders, isFullResponse?: boolean): Observable<T>;
    put<T>(url: string, body: any, httpHeadres?: HttpHeaders, isFullResponse?: boolean): Observable<T>;
    delete<T>(url: string, httpParams?: HttpParams, httpHeadres?: HttpHeaders, isFullResponse?: boolean): Observable<T>;
    patch<T>(url: string, body: any, httpHeadres: HttpHeaders, isFullResponse?: boolean): Observable<T>;
    private createOptional(httpParams, httpHeadres, isFullResponse?);
    private createHttpPrams(params);
    private createHttpHeader(header);
    private handleError(err);
}
export declare class AppInterceptor implements HttpInterceptor {
    localStorageCacheService: LocalStorageCacheService;
    tokenKey: string;
    tokenStorage: string;
    headerKey: string;
    prefixKey: string;
    logTime: boolean;
    constructor(localStorageCacheService: LocalStorageCacheService, tokenKey?: string, tokenStorage?: string, headerKey?: string, prefixKey?: string, logTime?: boolean);
    private getTokenKey();
    intercept(req: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
}
